package com.ibm.rational.rac.stop.service;

import java.io.File;

import org.eclipse.core.runtime.Platform;
import com.ibm.rational.rac.stop.service.ProcessHandler;

public class StopRACService {

    public void run(String[] arg) {
    	String RACPath = arg[0];
    	

		if (Platform.OS_WIN32.equals(Platform.getOS()) == true) {
			try {
				if (RACPath != null && RACPath.length()> 0) {
					String stopRACscript = RACPath + "\\AgentController\\bin\\RAStop.bat";
					
					//File stopRACscriptFile = new File(RACPath, "AgentController/bin/RAStop.bat");
					//if (stopRACscriptFile.exists()){
						//String[] cmd = {"cmd","/c","start","/MIN",stopRACscript};
						String[] cmd = {"cmd","/c",stopRACscript};
						Runtime rt = Runtime.getRuntime();
						Process myProc = rt.exec(cmd);
					
						/* handling the streams so that dead lock situation never occurs.  */
						ProcessHandler inputStream = new ProcessHandler(myProc.getInputStream(),"INPUT");
						ProcessHandler errorStream = new ProcessHandler(myProc.getErrorStream(),"ERROR");

						/* start the stream threads */
						inputStream.start();
						errorStream.start();

						// any error???
						int exitVal = myProc.waitFor();
						System.out.println("ExitValue: " + exitVal); 
					//}
				} 				
			}
			catch(Exception e) {
			}
		}else{
		//if (Platform.OS_LINUX.equals(Platform.getOS()) == true || Platform.OS_AIX.equals(Platform.getOS()) == true) {
			try {
				if (RACPath != null && RACPath.length()> 0) {
					File stopRACscriptFile = new File(RACPath, "AgentController/bin/RAStop.sh");
					String stopRACscript = stopRACscriptFile.getAbsolutePath();
					String[] cmd = {"sh",stopRACscript};
					Runtime rt = Runtime.getRuntime();
					Process myProc = rt.exec(cmd);
					//int exitValue = myProc.waitFor();
					
					/* handling the streams so that dead lock situation never occurs.  */
					ProcessHandler inputStream = new ProcessHandler(myProc.getInputStream(),"INPUT");
					ProcessHandler errorStream = new ProcessHandler(myProc.getErrorStream(),"ERROR");

					/* start the stream threads */
					inputStream.start();
					errorStream.start();
				} 
			}catch (Exception e){
			} 
		}
    }
}
